/*  	ccide - C Language Decision Table Code Generator 
	Copyright (C) 2002-2004,2010,2012;  Thomas W. Young, e-mail:  ccide@twyoung.com

    	This file is part of ccide, the C Language Decision Table Code Generator.

   	Ccide is free software: you can redistribute it and/or modify
   	it under the terms of the GNU General Public License as published by
    	the Free Software Foundation, either version 3 of the License, or
   	(at your option) any later version.

    	Ccide is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with Ccide.  If not, see <http://www.gnu.org/licenses/> or
    	write to the Free Software Foundation, Inc., 51 Franklin St, 
    	Fifth Floor, Boston, MA 02110-1301 USA.
*/

/* THISIS: errors.c.d 
	ERRORS.C has no purpose other than verifying ccide code generation.
*/

#include <stdio.h>
#include <stdlib.h>

/*CCIDE_INLINE_CODE:*/
/*GENERATED_CODE: */
#ifndef __CCIDE_INLINE_C
#define __CCIDE_INLINE_C

/*ccide-0.6.6-1
ccide is Copyright (C) 2002-2004,2010,2012;  Thomas W. Young, e-mail:  ccide@twyoung.com 
The code generated by ccide is covered by the same license as the source  
code(decision table) from which it is derived. If you created the source,  
you are free to do anything you like with the generated code, 
including incorporating it into or linking it with proprietary software.  
*/ 
static int ccide_group=1; 
#ifndef UINT_MAX 
#include "limits.h" 
#endif /* End if not defined UINT_MAX */ 
 
		/* Return rule number */ 
static int CCIDEFindRule(
	int nbrrules,  unsigned long ccide_table, unsigned long yes[], unsigned long no[]){ 
        int r=0; 
        unsigned long nstate; 
 
        nstate = UINT_MAX ^ ccide_table; 
 
        while ( 
		( (yes[r] & nstate) || (no[r]  & ccide_table) ) 
		 && ( ++r < nbrrules )  
	) {}; 
 
        return r; 
} 
 
static int CCIDEFindRuleYes(             /* Return rule number */
	int nbrrules, unsigned long ccide_table, unsigned long yes[]) 
{ 
        int r=0; 
        unsigned long nstate;
 
        nstate = UINT_MAX ^ ccide_table; 
        while ( (yes[r] & nstate) && ( ++r < nbrrules ) ) {}; 
        return r; 
} 
#endif /* End ifndef  __CCIDE_INLINE_C  */
/*END_GENERATED_CODE: */
int a1() {}
int a2() {}
int a3() {}

main() {
	int c2=2,c3=2,c4;
	int swvar[3][3]={{2,3,4},{3,4,2},{4,3,0}};


		/* N.B.: abort() is never executed.*/
	/*DECISION_TABLE:				*/
	/*   Y  N  Y  N | swvar[c2][c3] == 2		*/
	/*   N  N  N  Y | swvar[c3][c4] == 1		*/
        /*______________________________________________*/
	/*   -  -  -  - | abort()			*/
	/*   -  -  X  - | a1();				*/
	/*   -  X  X  - | a2();				*/
        /*END_TABLE:					*/
	/*GENERATED_CODE: FOR TABLE_1.*/
	/*WARNING: Dropping rule 4 in table 1. */

	/*ERROR: Rule 1 conflicts with rule  3 */
	/*	3 Rules, 2 conditions, and 3 actions.*/
	/*	Table 1 rule order = 1 2 3 */
	 {	unsigned long CCIDE_table1_yes[3]={   1UL,   0UL,   1UL};
		unsigned long CCIDE_table1_no[3]= {   2UL,   3UL,   2UL};


		switch(CCIDEFindRule(3,
			  (swvar[c2][c3] == 2)
			| (swvar[c3][c4] == 1)<<1
			  ,CCIDE_table1_yes, CCIDE_table1_no)) {
		case  2:	/*	Rule  3 */
		    a1();
		case  1:	/*	Rule  2 */
		    a2();
		    break;
		case  0:	/*	Rule  1 */
		    break;
		} /* End Switch*/
	}
	/*END_GENERATED_CODE: FOR TABLE_1, by ccide-0.6.6-1  */


	/*DECISION_TABLE:				*/
	/*   -  Y  -  N | swvar[c2][c3] == 2		*/
	/*   Y  N  -  N | swvar[c3][c4] == 1		*/
        /*______________________________________________*/
	/*   X  -  X  X | a1();				*/
	/*   X  X  X  - | a2();				*/
        /*END_TABLE:					*/
	/*GENERATED_CODE: FOR TABLE_2.*/

	/*ERROR: Rules  1 and   3 overlap.
 */
	/*	4 Rules, 2 conditions, and 2 actions.*/
	/*	Table 2 rule order = 2 4 1 3 */
	 {	unsigned long CCIDE_table2_yes[4]={   1UL,   0UL,   2UL,   0UL};
		unsigned long CCIDE_table2_no[4]= {   2UL,   3UL,   0UL,   0UL};


		switch(CCIDEFindRule(4,
			  (swvar[c2][c3] == 2)
			| (swvar[c3][c4] == 1)<<1
			  ,CCIDE_table2_yes, CCIDE_table2_no)) {
		case  2:	/*	Rule  1 */
		case  3:	/*	Rule  3 */
		    a1();
		case  0:	/*	Rule  2 */
		    a2();
		    break;
		case  1:	/*	Rule  4 */
		    a1();
		    break;
		} /* End Switch*/
	}
	/*END_GENERATED_CODE: FOR TABLE_2, by ccide-0.6.6-1  */

	/*DECISION_TABLE:				*/
	/*   -  Y  N  N | swvar[c1][c2] == 2		*/
	/*   Y  N  Y  N | swvar[c3][c4] == 1		*/
	/*   Y  N  Y  N | swvar[c1][c2] == 2		*/
	/*ERROR: swvar[c1][c2] == 2 is the same as condition 1 */

        /*______________________________________________*/
	/*   X  -  X  X | a1();				*/
	/*   X  X  X  - | a2();				*/
	/* END_TABLE:*/

	/* DECISION_TABLE:*/
	/*   -YNN | swvar[c1][c2] == 2		*/
	/*ERROR: 1 règles au lieu de 4. */

	/* YNYN | swvar[c3][c4] == 1		*/
	/*ERROR: 0 règles au lieu de 4. */

	/* YNYN | swvar[c1][c2] == 2		*/
	/*ERROR: swvar[c1][c2] == 2 is the same as action 3 */

	/*ERROR: 0 règles au lieu de 4. */

	/* ______________________________________________*/
	/*   X  -  X  X | a1();				*/
	/*ERROR: a1(); is the same as action 1 */

	/*   X  X  X  - | a2();				*/
	/*ERROR: a2(); is the same as action 2 */

	/*   -  X  -  - | a1();				*/
	/*ERROR: a1(); is the same as action 1 */

	/*ERROR: a1(); is the same as action 6 */

        /*END_TABLE:					*/
	/*GENERATED_CODE: FOR TABLE_3.*/
	/*	4 Rules, 3 conditions, and 8 actions.*/
	/*	Table 3 rule order = 2 3 4 1 */
	 {	unsigned long CCIDE_table3_yes[4]={   1UL,   6UL,   0UL,   6UL};
		unsigned long CCIDE_table3_no[4]= {   6UL,   1UL,   7UL,   0UL};


		switch(CCIDEFindRule(4,
			  (swvar[c1][c2] == 2)
			| (swvar[c3][c4] == 1)<<1
			| (swvar[c1][c2] == 2)<<2
			  ,CCIDE_table3_yes, CCIDE_table3_no)) {
		case  0:	/*	Rule  2 */
		    a2();
		    a2();
		    a1();
		    break;
		case  1:	/*	Rule  3 */
		case  3:	/*	Rule  1 */
		    a1();
		    a2();
		    a1();
		    a2();
		    break;
		case  2:	/*	Rule  4 */
		    a1();
		    a1();
		    break;
		} /* End Switch*/
	}
	/*END_GENERATED_CODE: FOR TABLE_3, by ccide-0.6.6-1  */

	/*DECISION_TABLE:				*/
	/*   -  Y  N  N | swvar[c2][c3] == 2		*/
	/*   Y  N  Y  N | swvar[c3][c4] = 1		*/
	/*ERROR:  '=' probably should be '==' in condition stub 2 */

        /*______________________________________________*/
	/*   X  -  X  X | a1();				*/
	/*   X  X  X  - | a2();				*/
	/* END_TABLE:
return0	; 
}
